
#define CLOCK    RB0_bit
#define DATA     RB1_bit

#include "LCD_2x16_74LS174.h"

void lcd_cmd(char letter)
{
    char temp;
    temp = letter;
    temp = temp>>4;
    lcd_nybble(temp,0);
    temp = letter;
    temp = temp&0x0f;
    lcd_nybble(temp,0);
}

void lcd_char(char letter)
{
    char temp;
    temp = letter;
    temp = temp >> 4;
    lcd_nybble(temp,1);
    temp = letter;
    temp = temp & 0x0f;
    lcd_nybble(temp,1);
}

void lcd_nybble(char nyb, char rs)
{
    int i;
    DATA = 0;                   //clear the 174
    for(i=0;i<6;i++){           //repeat for 6 bits
        CLOCK=1;delay_us(50);CLOCK=0;        //write 0's to the 174
    }
    DATA=1;                     //output the AND value
    CLOCK=1;delay_us(50);CLOCK=0;
    DATA=rs;                    //output the RS bit value
    CLOCK=1;delay_us(50);CLOCK=0;
    for(i=0;i<4;i++){           //output the nybble
        if((nyb & 0x08) != 0)
            DATA=1;
        else
            DATA=0;
        CLOCK=1;delay_us(50);CLOCK=0;
        nyb=nyb<<1;
    }
    e_togg();
}

void LCD_String_xy (char row, char pos, char *str)  /* Send string to LCD function */
{
  short i=0;
  switch(row){
    case 1:
      lcd_cmd(0x80);
      break;
    case 2:
      lcd_cmd(0xC0);
      break;
    case 3:
      lcd_cmd(0x94);
      break;
    case 4:
      lcd_cmd(0xD4);
    break;
   }

   for(i=1; i<pos; i++){
      lcd_char(32);
   }
  while(*str)              // Write data to LCD up to null
{
    lcd_char(*str);
    str++;               // Increment buffer
}

return;
}

void LCD_Char_xy (char row, char pos, char ch)  /* Send string to LCD function */
{

   if((pos-1) == 0)   lcd_cmd(0x80 | (row-1));
   else  lcd_cmd(0x80 | 0x40 | (row-1));

   lcd_char(ch);  /* Call LCD data write */

}
void lcd_init(void)
{
    delay_ms(20);
    lcd_nybble(0x03,0);
    delay_ms(5);
    e_togg();
    delay_us(160);
    e_togg();
    delay_us(160);
    lcd_nybble(0x02,0);
    delay_us(160);
    lcd_cmd(0x28);                    //set 4-bit mode and 2 lines
    delay_us(160);
    lcd_cmd(0x10);                    //cursor move & shift left
    delay_us(160);
    lcd_cmd(0x06);                    //entry mode = increment
    delay_us(160);
    lcd_cmd(0x01);                    //clear display
    delay_us(160);
    Lcd_cmd(display_on); // Display ON Cursor OFF 

}

void e_togg(void)
{
    DATA=1;
    delay_us(50);
    DATA=0;
}